/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of CommonMark.xs. Do not edit this file, edit CommonMark.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "CommonMark.xs"
/*
 * Notes on memory management
 *
 * - A pointer to the Perl SV representing a node is stored in the
 *   user data slot of `struct cmark_node`, so there's a 1:1 mapping
 *   between Perl and C objects.
 * - Every node SV keeps a reference to the parent SV. This is done
 *   by looking up the parent SV via user data and increasing its refcount.
 * - This makes sure that a document isn't freed if the last reference
 *   from Perl to the root node is dropped, while references to child nodes
 *   might still exist.
 * - As a consequence, as long as a node is referenced from Perl, all its
 *   ancestor nodes will also be associated with a Perl object.
 */

#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdlib.h>
#include <cmark.h>

#if CMARK_VERSION < 0x001500
  #error libcmark 0.21.0 is required.
#endif

#if PERL_VERSION <= 8
  #define SvREFCNT_inc_simple_void_NN SvREFCNT_inc
#endif
#if PERL_VERSION <= 14
  #define sv_derived_from_pvn(sv, name, len, flags) sv_derived_from(sv, name)
#endif

/* Fix prefixes of render functions. */
#define cmark_node_render_html        cmark_render_html
#define cmark_node_render_xml         cmark_render_xml
#define cmark_node_render_man         cmark_render_man
#define cmark_node_render_commonmark  cmark_render_commonmark
#define cmark_node_render_latex       cmark_render_latex

/* Backward compatibility */

#if CMARK_VERSION < 0x001700

    /* Older than 0.23.0 */

    static const char*
    S_unsupported_get_utf8(cmark_node *node) {
        (void)node;
        return NULL;
    }

    static const char*
    S_unsupported_set_utf8(cmark_node *node, const char *val) {
        (void)node;
        (void)val;
        return 0;
    }

    #define cmark_node_get_on_enter  S_unsupported_get_utf8
    #define cmark_node_get_on_exit   S_unsupported_get_utf8
    #define cmark_node_set_on_enter  S_unsupported_set_utf8
    #define cmark_node_set_on_exit   S_unsupported_set_utf8

#endif /* CMARK_VERSION < 0x001700 */

#ifdef CMARK_OPT_UNSAFE
  #define OPT_UNSAFE CMARK_OPT_UNSAFE
#else
  /* Hardcoded value, ignored by old libcmark versions. */
  #define OPT_UNSAFE (1 << 17)
#endif

static SV*
S_create_or_incref_node_sv(pTHX_ cmark_node *node) {
    SV *new_obj = NULL;

    while (node) {
        SV *obj;
        HV *stash;

        /* Look for existing object. */
        obj = (SV*)cmark_node_get_user_data(node);

        if (obj) {
            /* Incref if found. */
            SvREFCNT_inc_simple_void_NN(obj);
            if (!new_obj) {
                new_obj = obj;
            }
            break;
        }

        /* Create a new SV. */
        obj = newSViv(PTR2IV(node));
        cmark_node_set_user_data(node, obj);
        if (!new_obj) {
            new_obj = obj;
        }

        /*
         * Unfortunately, Perl doesn't offer an API function to bless an SV
         * without a reference. The following code is mostly copied from
         * sv_bless.
         */
        SvOBJECT_on(obj);
#if PERL_VERSION <= 16
        PL_sv_objcount++;
#endif
        SvUPGRADE(obj, SVt_PVMG);
        stash = gv_stashpvn("CommonMark::Node", 16, GV_ADD);
        SvSTASH_set(obj, (HV*)SvREFCNT_inc(stash));

        /* Recurse into parent. */
        node = cmark_node_parent(node);
    }

    return new_obj;
}

static void
S_decref_node_sv(pTHX_ cmark_node *node) {
    SV *obj;

    if (!node) {
        return;
    }

    obj = (SV*)cmark_node_get_user_data(node);
    if (!obj) {
        /* Should never happen. */
        croak("Internal error: node SV not found");
    }

    SvREFCNT_dec(obj);
}

/* Find or create an SV for a cmark_node. */
static SV*
S_node2sv(pTHX_ cmark_node *node) {
    SV *obj;

    if (!node) {
        return &PL_sv_undef;
    }

    obj = S_create_or_incref_node_sv(aTHX_ node);

    return newRV_noinc(obj);
}

/* Transfer refcount from a node to another. */
static void
S_transfer_refcount(pTHX_ cmark_node *from, cmark_node *to) {
    if (from != to) {
        /*
         * It is important to incref first, then decref. Otherwise, node SVs
         * of ancestors could be needlessly destroyed and recreated when
         * transferring a sole reference to a nearby node.
         */
        S_create_or_incref_node_sv(aTHX_ to);
        S_decref_node_sv(aTHX_ from);
    }
}

/* Get C struct pointer from an SV argument. */
static void*
S_sv2c(pTHX_ SV *sv, const char *class_name, STRLEN len, CV *cv,
       const char *var_name) {
    if (!SvROK(sv) || !sv_derived_from_pvn(sv, class_name, len, 0)) {
        const char *sub_name = GvNAME(CvGV(cv));
        croak("%s: %s is not of type %s", sub_name, var_name, class_name);
    }
    return INT2PTR(void*, SvIV(SvRV(sv)));
}

/* Handle SAFE/UNSAFE options. */
static int
S_process_options(int options) {
    if (options & CMARK_OPT_SAFE) {
        /* SAFE takes predence over UNSAFE. */
        options &= ~OPT_UNSAFE;
    }
    else if ((options & OPT_UNSAFE) == 0) {
        /* For old libcmark versions, set SAFE unless UNSAFE was set. */
        options |= CMARK_OPT_SAFE;
    }
    return options;
}


#line 204 "CommonMark.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 348 "CommonMark.c"

XS_EUPXS(XS_CommonMark_markdown_to_html); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark_markdown_to_html)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "package, string, options = 0");
    {
	SV *	package;
	SV *	string = ST(1)
;
	int	options;
#line 288 "CommonMark.xs"
    STRLEN len;
    const char *buffer;
#line 364 "CommonMark.c"
	char *	RETVAL;

	if (items < 3)
	    options = 0;
	else {
	    options = (int)SvIV(ST(2))
;
	}
#line 291 "CommonMark.xs"
    (void)package;
    buffer = SvPVutf8(string, len);
    options = S_process_options(options);
    RETVAL = cmark_markdown_to_html(buffer, len, options);
#line 378 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = newSVpv(RETVAL, 0);
    SvUTF8_on(RETVALSV);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark_parse_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark_parse_document)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "package, string, options = 0");
    {
	SV *	package;
	SV *	string = ST(1)
;
	int	options;
#line 304 "CommonMark.xs"
    STRLEN len;
    const char *buffer;
#line 405 "CommonMark.c"
	cmark_node *	RETVAL;

	if (items < 3)
	    options = 0;
	else {
	    options = (int)SvIV(ST(2))
;
	}
#line 307 "CommonMark.xs"
    (void)package;
    buffer = SvPVutf8(string, len);
    RETVAL = cmark_parse_document(buffer, len, options);
    if (RETVAL == NULL) {
        croak("parse_document: unknown error");
    }
#line 421 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = S_node2sv(aTHX_ RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark_parse_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark_parse_file)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "package, file, options = 0");
    {
	SV *	package;
	SV *	file = ST(1)
;
	int	options;
#line 322 "CommonMark.xs"
    PerlIO *perl_io;
    FILE *stream = NULL;
#line 447 "CommonMark.c"
	cmark_node *	RETVAL;

	if (items < 3)
	    options = 0;
	else {
	    options = (int)SvIV(ST(2))
;
	}
#line 325 "CommonMark.xs"
    (void)package;
    perl_io = IoIFP(sv_2io(file));
    if (perl_io) {
        stream = PerlIO_findFILE(perl_io);
    }
    if (!stream) {
        croak("parse_file: file is not a file handle");
    }
    RETVAL = cmark_parse_file(stream, options);
    if (RETVAL == NULL) {
        croak("parse_file: unknown error");
    }
#line 469 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = S_node2sv(aTHX_ RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	SV *	package;
	int	RETVAL;
#line 344 "CommonMark.xs"
    (void)package;
    RETVAL = cmark_version();
#line 493 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = newSViv((IV)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark_version_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark_version_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	SV *	package;
	const char *	RETVAL;
#line 353 "CommonMark.xs"
    (void)package;
    RETVAL = cmark_version_string();
#line 517 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = newSVpv(RETVAL, 0);
    SvUTF8_on(RETVALSV);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark_compile_time_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark_compile_time_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	SV *	package;
	int	RETVAL;
#line 362 "CommonMark.xs"
    (void)package;
    RETVAL = CMARK_VERSION;
#line 542 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = newSViv((IV)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark_compile_time_version_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark_compile_time_version_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	SV *	package;
	const char *	RETVAL;
#line 371 "CommonMark.xs"
    (void)package;
    RETVAL = CMARK_VERSION_STRING;
#line 566 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = newSVpv(RETVAL, 0);
    SvUTF8_on(RETVALSV);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Node_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, type");
    {
	SV *	package;
	cmark_node_type	type = (cmark_node_type)SvIV(ST(1))
;
	cmark_node *	RETVAL;
#line 384 "CommonMark.xs"
    (void)package;
    RETVAL = cmark_node_new(type);
    if (RETVAL == NULL) {
        croak("new: out of memory");
    }
#line 596 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = S_node2sv(aTHX_ RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Node_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "node");
    {
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
#line 395 "CommonMark.xs"
    cmark_node *parent = cmark_node_parent(node);
    if (parent) {
        cmark_node_set_user_data(node, NULL);
        S_decref_node_sv(aTHX_ parent);
    }
    else {
        cmark_node_free(node);
    }
#line 627 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Node_iterator); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_iterator)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "node");
    {
	cmark_iter *	RETVAL;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
#line 407 "CommonMark.xs"
    S_create_or_incref_node_sv(aTHX_ node);
    RETVAL = cmark_iter_new(node);
    if (RETVAL == NULL) {
        croak("iterator: out of memory");
    }
#line 650 "CommonMark.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "CommonMark::Iterator", RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Node_interface_get_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_get_node)
{
    dVAR; dXSARGS;
    dXSFUNCTION(cmark_node *);
    if (items != 1)
       croak_xs_usage(cv,  "node");
    {
	cmark_node *	RETVAL;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
    XSFUNCTION = XSINTERFACE_FUNC(cmark_node *,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(node);
	{
	    SV * RETVALSV;
    RETVALSV = S_node2sv(aTHX_ RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Node_interface_get_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_get_int)
{
    dVAR; dXSARGS;
    dXSFUNCTION(int);
    if (items != 1)
       croak_xs_usage(cv,  "node");
    {
	int	RETVAL;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
    XSFUNCTION = XSINTERFACE_FUNC(int,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(node);
	{
	    SV * RETVALSV;
    RETVALSV = newSViv((IV)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Node_interface_set_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_set_int)
{
    dVAR; dXSARGS;
    dXSFUNCTION(int);
    if (items != 2)
       croak_xs_usage(cv,  "node, value");
    {
	int	RETVAL;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
	int	value = (int)SvIV(ST(1))
;
    XSFUNCTION = XSINTERFACE_FUNC(int,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(node, value);
#line 447 "CommonMark.xs"
    if (!RETVAL) {
        croak("%s: invalid operation", GvNAME(CvGV(cv)));
    }
#line 735 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Node_interface_get_utf8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_get_utf8)
{
    dVAR; dXSARGS;
    dXSFUNCTION(const char *);
    if (items != 1)
       croak_xs_usage(cv,  "node");
    {
	const char *	RETVAL;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
    XSFUNCTION = XSINTERFACE_FUNC(const char *,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(node);
	{
	    SV * RETVALSV;
    RETVALSV = newSVpv(RETVAL, 0);
    SvUTF8_on(RETVALSV);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Node_interface_set_utf8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_set_utf8)
{
    dVAR; dXSARGS;
    dXSFUNCTION(int);
    if (items != 2)
       croak_xs_usage(cv,  "node, value");
    {
	int	RETVAL;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
	const char *    value = SvPVutf8_nolen(ST(1))
;
    XSFUNCTION = XSINTERFACE_FUNC(int,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(node, value);
#line 472 "CommonMark.xs"
    if (!RETVAL) {
        croak("%s: invalid operation", GvNAME(CvGV(cv)));
    }
#line 789 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Node_unlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_unlink)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "node");
    {
#line 479 "CommonMark.xs"
    cmark_node *old_parent;
#line 804 "CommonMark.c"
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
#line 481 "CommonMark.xs"
    old_parent = cmark_node_parent(node);
#line 810 "CommonMark.c"

	cmark_node_unlink(node);
#line 483 "CommonMark.xs"
    S_decref_node_sv(aTHX_ old_parent);
#line 815 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Node_replace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_replace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "node, other");
    {
#line 488 "CommonMark.xs"
    cmark_node *old_parent;
    int         retval;
#line 831 "CommonMark.c"
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
	cmark_node *    other = (cmark_node*)S_sv2c(aTHX_ ST(1), "CommonMark::Node", 16, cv,
                               "other")
;
#line 491 "CommonMark.xs"
    old_parent = cmark_node_parent(other);
#if CMARK_VERSION < 0x001800
    /* Older than 0.24.0 */
    retval = cmark_node_insert_before(node, other);
    if (retval) {
        cmark_node_unlink(node);
    }
#else
    retval = cmark_node_replace(node, other);
#endif
    if (!retval) {
        croak("replace: invalid operation");
    }
    S_decref_node_sv(aTHX_ old_parent);
#line 853 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Node_interface_move_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_move_node)
{
    dVAR; dXSARGS;
    dXSFUNCTION(int);
    if (items != 2)
       croak_xs_usage(cv,  "node, other");
    {
#line 509 "CommonMark.xs"
    cmark_node *old_parent;
    cmark_node *new_parent;
#line 870 "CommonMark.c"
	int	RETVAL;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "node")
;
	cmark_node *    other = (cmark_node*)S_sv2c(aTHX_ ST(1), "CommonMark::Node", 16, cv,
                               "other")
;
#line 512 "CommonMark.xs"
    old_parent = cmark_node_parent(other);
#line 880 "CommonMark.c"
    XSFUNCTION = XSINTERFACE_FUNC(int,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(node, other);
#line 519 "CommonMark.xs"
    if (!RETVAL) {
        croak("%s: invalid operation", GvNAME(CvGV(cv)));
    }
    new_parent = cmark_node_parent(other);
    S_transfer_refcount(aTHX_ old_parent, new_parent);
#line 890 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Node_interface_render); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_render)
{
    dVAR; dXSARGS;
    dXSFUNCTION(char *);
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "root, options= 0");
    {
	char *	RETVAL;
	cmark_node *    root = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "root")
;
	int	options;

	if (items < 2)
	    options = 0;
	else {
	    options = (int)SvIV(ST(1))
;
	}
#line 528 "CommonMark.xs"
    options = S_process_options(options);
#line 918 "CommonMark.c"
    XSFUNCTION = XSINTERFACE_FUNC(char *,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(root, options);
	{
	    SV * RETVALSV;
    RETVALSV = newSVpv(RETVAL, 0);
    SvUTF8_on(RETVALSV);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Node_interface_render_width); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Node_interface_render_width)
{
    dVAR; dXSARGS;
    dXSFUNCTION(char *);
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "root, options= 0, width= 0");
    {
	char *	RETVAL;
	cmark_node *    root = (cmark_node*)S_sv2c(aTHX_ ST(0), "CommonMark::Node", 16, cv,
                               "root")
;
	int	options;
	int	width;

	if (items < 2)
	    options = 0;
	else {
	    options = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    width = 0;
	else {
	    width = (int)SvIV(ST(2))
;
	}
#line 536 "CommonMark.xs"
    options = S_process_options(options);
#line 964 "CommonMark.c"
    XSFUNCTION = XSINTERFACE_FUNC(char *,cv,XSANY.any_dptr);

	RETVAL = XSFUNCTION(root, options, width);
	{
	    SV * RETVALSV;
    RETVALSV = newSVpv(RETVAL, 0);
    SvUTF8_on(RETVALSV);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Iterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Iterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	cmark_iter *    iter = (cmark_iter*)S_sv2c(aTHX_ ST(0), "CommonMark::Iterator", 20, cv,
                               "iter")
;
#line 548 "CommonMark.xs"
    S_decref_node_sv(aTHX_ cmark_iter_get_node(iter));
    S_decref_node_sv(aTHX_ cmark_iter_get_root(iter));
    cmark_iter_free(iter);
#line 994 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Iterator_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Iterator_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 555 "CommonMark.xs"
    I32 gimme;
    cmark_node *old_node;
    cmark_event_type ev_type;
#line 1013 "CommonMark.c"
	cmark_iter *    iter = (cmark_iter*)S_sv2c(aTHX_ ST(0), "CommonMark::Iterator", 20, cv,
                               "iter")
;
#line 559 "CommonMark.xs"
    gimme    = GIMME_V;
    old_node = cmark_iter_get_node(iter);
    ev_type  = cmark_iter_next(iter);

    if (ev_type != CMARK_EVENT_DONE) {
        cmark_node *node = cmark_iter_get_node(iter);

        ST(0) = sv_2mortal(newSViv((IV)ev_type));

        if (gimme == G_ARRAY) {
            SV *obj = S_create_or_incref_node_sv(aTHX_ node);

            /* A bit more efficient than S_transfer_refcount. */
            if (old_node != node) {
                S_decref_node_sv(aTHX_ old_node);
                SvREFCNT_inc_simple_void_NN(obj);
            }

            ST(1) = sv_2mortal(newRV_noinc(obj));
            XSRETURN(2);
        }
        else {
            S_transfer_refcount(aTHX_ old_node, node);
            XSRETURN(1);
        }
    }
    else {
        S_decref_node_sv(aTHX_ old_node);

        if (gimme == G_ARRAY) {
            XSRETURN_EMPTY;
        }
        else {
            ST(0) = sv_2mortal(newSViv((IV)ev_type));
            XSRETURN(1);
        }
    }
#line 1055 "CommonMark.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_CommonMark__Iterator_get_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Iterator_get_node)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	cmark_node *	RETVAL;
	cmark_iter *    iter = (cmark_iter*)S_sv2c(aTHX_ ST(0), "CommonMark::Iterator", 20, cv,
                               "iter")
;

	RETVAL = cmark_iter_get_node(iter);
	{
	    SV * RETVALSV;
    RETVALSV = S_node2sv(aTHX_ RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Iterator_get_event_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Iterator_get_event_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iter");
    {
	cmark_event_type	RETVAL;
	cmark_iter *    iter = (cmark_iter*)S_sv2c(aTHX_ ST(0), "CommonMark::Iterator", 20, cv,
                               "iter")
;

	RETVAL = cmark_iter_get_event_type(iter);
	{
	    SV * RETVALSV;
    RETVALSV = newSViv((IV)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Iterator_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Iterator_reset)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "iter, node, event_type");
    {
	cmark_iter *    iter = (cmark_iter*)S_sv2c(aTHX_ ST(0), "CommonMark::Iterator", 20, cv,
                               "iter")
;
	cmark_node *    node = (cmark_node*)S_sv2c(aTHX_ ST(1), "CommonMark::Node", 16, cv,
                               "node")
;
	cmark_event_type	event_type = (cmark_event_type)SvIV(ST(2))
;
#line 609 "CommonMark.xs"
    cmark_node *old_node;
#line 1127 "CommonMark.c"
#line 611 "CommonMark.xs"
    old_node = cmark_iter_get_node(iter);
    S_transfer_refcount(aTHX_ old_node, node);
#line 1131 "CommonMark.c"

	cmark_iter_reset(iter, node, event_type);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Parser_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Parser_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "package, options = 0");
    {
	SV *	package;
	int	options;
	cmark_parser *	RETVAL;

	if (items < 2)
	    options = 0;
	else {
	    options = (int)SvIV(ST(1))
;
	}
#line 622 "CommonMark.xs"
    (void)package;
    RETVAL = cmark_parser_new(options);
    if (RETVAL == NULL) {
        croak("new: out of memory");
    }
#line 1162 "CommonMark.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "CommonMark::Parser", RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CommonMark__Parser_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Parser_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "parser");
    {
	cmark_parser *    parser = (cmark_parser*)S_sv2c(aTHX_ ST(0), "CommonMark::Parser", 18, cv,
                                 "parser")
;
#line 633 "CommonMark.xs"
    cmark_parser_free(parser);
#line 1186 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Parser_feed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Parser_feed)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "parser, string");
    {
#line 638 "CommonMark.xs"
    STRLEN len;
    const char *buffer;
#line 1202 "CommonMark.c"
	cmark_parser *    parser = (cmark_parser*)S_sv2c(aTHX_ ST(0), "CommonMark::Parser", 18, cv,
                                 "parser")
;
	SV *	string = ST(1)
;
#line 641 "CommonMark.xs"
    buffer = SvPVutf8(string, len);
    cmark_parser_feed(parser, buffer, len);
#line 1211 "CommonMark.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_CommonMark__Parser_finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CommonMark__Parser_finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "parser");
    {
	cmark_node *	RETVAL;
	cmark_parser *    parser = (cmark_parser*)S_sv2c(aTHX_ ST(0), "CommonMark::Parser", 18, cv,
                                 "parser")
;

	RETVAL = cmark_parser_finish(parser);
#line 647 "CommonMark.xs"
    if (RETVAL == NULL) {
        croak("finish: unknown error");
    }
#line 1234 "CommonMark.c"
	{
	    SV * RETVALSV;
    RETVALSV = S_node2sv(aTHX_ RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_CommonMark); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_CommonMark)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        newXS_deffile("CommonMark::markdown_to_html", XS_CommonMark_markdown_to_html);
        newXS_deffile("CommonMark::parse_document", XS_CommonMark_parse_document);
        newXS_deffile("CommonMark::parse_file", XS_CommonMark_parse_file);
        newXS_deffile("CommonMark::version", XS_CommonMark_version);
        newXS_deffile("CommonMark::version_string", XS_CommonMark_version_string);
        newXS_deffile("CommonMark::compile_time_version", XS_CommonMark_compile_time_version);
        newXS_deffile("CommonMark::compile_time_version_string", XS_CommonMark_compile_time_version_string);
        newXS_deffile("CommonMark::Node::new", XS_CommonMark__Node_new);
        newXS_deffile("CommonMark::Node::DESTROY", XS_CommonMark__Node_DESTROY);
        newXS_deffile("CommonMark::Node::iterator", XS_CommonMark__Node_iterator);
        cv = newXS_deffile("CommonMark::Node::first_child", XS_CommonMark__Node_interface_get_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_first_child);
        cv = newXS_deffile("CommonMark::Node::last_child", XS_CommonMark__Node_interface_get_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_last_child);
        cv = newXS_deffile("CommonMark::Node::next", XS_CommonMark__Node_interface_get_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_next);
        cv = newXS_deffile("CommonMark::Node::parent", XS_CommonMark__Node_interface_get_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_parent);
        cv = newXS_deffile("CommonMark::Node::previous", XS_CommonMark__Node_interface_get_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_previous);
        cv = newXS_deffile("CommonMark::Node::get_end_column", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_end_column);
        cv = newXS_deffile("CommonMark::Node::get_end_line", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_end_line);
        cv = newXS_deffile("CommonMark::Node::get_header_level", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_header_level);
        cv = newXS_deffile("CommonMark::Node::get_list_delim", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_list_delim);
        cv = newXS_deffile("CommonMark::Node::get_list_start", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_list_start);
        cv = newXS_deffile("CommonMark::Node::get_list_tight", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_list_tight);
        cv = newXS_deffile("CommonMark::Node::get_list_type", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_list_type);
        cv = newXS_deffile("CommonMark::Node::get_start_column", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_start_column);
        cv = newXS_deffile("CommonMark::Node::get_start_line", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_start_line);
        cv = newXS_deffile("CommonMark::Node::get_type", XS_CommonMark__Node_interface_get_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_type);
        cv = newXS_deffile("CommonMark::Node::set_header_level", XS_CommonMark__Node_interface_set_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_header_level);
        cv = newXS_deffile("CommonMark::Node::set_list_delim", XS_CommonMark__Node_interface_set_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_list_delim);
        cv = newXS_deffile("CommonMark::Node::set_list_start", XS_CommonMark__Node_interface_set_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_list_start);
        cv = newXS_deffile("CommonMark::Node::set_list_tight", XS_CommonMark__Node_interface_set_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_list_tight);
        cv = newXS_deffile("CommonMark::Node::set_list_type", XS_CommonMark__Node_interface_set_int);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_list_type);
        cv = newXS_deffile("CommonMark::Node::get_fence_info", XS_CommonMark__Node_interface_get_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_fence_info);
        cv = newXS_deffile("CommonMark::Node::get_literal", XS_CommonMark__Node_interface_get_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_literal);
        cv = newXS_deffile("CommonMark::Node::get_on_enter", XS_CommonMark__Node_interface_get_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_on_enter);
        cv = newXS_deffile("CommonMark::Node::get_on_exit", XS_CommonMark__Node_interface_get_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_on_exit);
        cv = newXS_deffile("CommonMark::Node::get_title", XS_CommonMark__Node_interface_get_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_title);
        cv = newXS_deffile("CommonMark::Node::get_type_string", XS_CommonMark__Node_interface_get_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_type_string);
        cv = newXS_deffile("CommonMark::Node::get_url", XS_CommonMark__Node_interface_get_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_get_url);
        cv = newXS_deffile("CommonMark::Node::set_fence_info", XS_CommonMark__Node_interface_set_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_fence_info);
        cv = newXS_deffile("CommonMark::Node::set_literal", XS_CommonMark__Node_interface_set_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_literal);
        cv = newXS_deffile("CommonMark::Node::set_on_enter", XS_CommonMark__Node_interface_set_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_on_enter);
        cv = newXS_deffile("CommonMark::Node::set_on_exit", XS_CommonMark__Node_interface_set_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_on_exit);
        cv = newXS_deffile("CommonMark::Node::set_title", XS_CommonMark__Node_interface_set_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_title);
        cv = newXS_deffile("CommonMark::Node::set_url", XS_CommonMark__Node_interface_set_utf8);
        XSINTERFACE_FUNC_SET(cv,cmark_node_set_url);
        newXS_deffile("CommonMark::Node::unlink", XS_CommonMark__Node_unlink);
        newXS_deffile("CommonMark::Node::replace", XS_CommonMark__Node_replace);
        cv = newXS_deffile("CommonMark::Node::append_child", XS_CommonMark__Node_interface_move_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_append_child);
        cv = newXS_deffile("CommonMark::Node::insert_after", XS_CommonMark__Node_interface_move_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_insert_after);
        cv = newXS_deffile("CommonMark::Node::insert_before", XS_CommonMark__Node_interface_move_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_insert_before);
        cv = newXS_deffile("CommonMark::Node::prepend_child", XS_CommonMark__Node_interface_move_node);
        XSINTERFACE_FUNC_SET(cv,cmark_node_prepend_child);
        cv = newXS_deffile("CommonMark::Node::render_html", XS_CommonMark__Node_interface_render);
        XSINTERFACE_FUNC_SET(cv,cmark_node_render_html);
        cv = newXS_deffile("CommonMark::Node::render_xml", XS_CommonMark__Node_interface_render);
        XSINTERFACE_FUNC_SET(cv,cmark_node_render_xml);
        cv = newXS_deffile("CommonMark::Node::render_commonmark", XS_CommonMark__Node_interface_render_width);
        XSINTERFACE_FUNC_SET(cv,cmark_node_render_commonmark);
        cv = newXS_deffile("CommonMark::Node::render_latex", XS_CommonMark__Node_interface_render_width);
        XSINTERFACE_FUNC_SET(cv,cmark_node_render_latex);
        cv = newXS_deffile("CommonMark::Node::render_man", XS_CommonMark__Node_interface_render_width);
        XSINTERFACE_FUNC_SET(cv,cmark_node_render_man);
        newXS_deffile("CommonMark::Iterator::DESTROY", XS_CommonMark__Iterator_DESTROY);
        newXS_deffile("CommonMark::Iterator::next", XS_CommonMark__Iterator_next);
        newXS_deffile("CommonMark::Iterator::get_node", XS_CommonMark__Iterator_get_node);
        newXS_deffile("CommonMark::Iterator::get_event_type", XS_CommonMark__Iterator_get_event_type);
        newXS_deffile("CommonMark::Iterator::reset", XS_CommonMark__Iterator_reset);
        newXS_deffile("CommonMark::Parser::new", XS_CommonMark__Parser_new);
        newXS_deffile("CommonMark::Parser::DESTROY", XS_CommonMark__Parser_DESTROY);
        newXS_deffile("CommonMark::Parser::feed", XS_CommonMark__Parser_feed);
        newXS_deffile("CommonMark::Parser::finish", XS_CommonMark__Parser_finish);
    }

    /* Initialisation Section */

#line 199 "CommonMark.xs"
    { /* Block required for C89 compilers. */
        static const struct {
            const char *name;
            int value;
        } constants[] = {
            { "NODE_NONE", CMARK_NODE_NONE },
            { "NODE_DOCUMENT", CMARK_NODE_DOCUMENT },
            { "NODE_BLOCK_QUOTE", CMARK_NODE_BLOCK_QUOTE },
            { "NODE_LIST", CMARK_NODE_LIST },
            { "NODE_ITEM", CMARK_NODE_ITEM },
            { "NODE_CODE_BLOCK", CMARK_NODE_CODE_BLOCK },
            { "NODE_HTML", CMARK_NODE_HTML },
            { "NODE_PARAGRAPH", CMARK_NODE_PARAGRAPH },
            { "NODE_HEADER", CMARK_NODE_HEADER },
            { "NODE_HRULE", CMARK_NODE_HRULE },
            { "NODE_TEXT", CMARK_NODE_TEXT },
            { "NODE_SOFTBREAK", CMARK_NODE_SOFTBREAK },
            { "NODE_LINEBREAK", CMARK_NODE_LINEBREAK },
            { "NODE_CODE", CMARK_NODE_CODE },
            { "NODE_INLINE_HTML", CMARK_NODE_INLINE_HTML },
            { "NODE_EMPH", CMARK_NODE_EMPH },
            { "NODE_STRONG", CMARK_NODE_STRONG },
            { "NODE_LINK", CMARK_NODE_LINK },
            { "NODE_IMAGE", CMARK_NODE_IMAGE },
#if CMARK_VERSION >= 0x001700
            /* libcmark 0.23.0 */
            { "NODE_CUSTOM_BLOCK", CMARK_NODE_CUSTOM_BLOCK },
            { "NODE_CUSTOM_INLINE", CMARK_NODE_CUSTOM_INLINE },
            { "NODE_HTML_BLOCK", CMARK_NODE_HTML_BLOCK },
            { "NODE_HEADING", CMARK_NODE_HEADING },
            { "NODE_THEMATIC_BREAK", CMARK_NODE_THEMATIC_BREAK },
            { "NODE_HTML_INLINE", CMARK_NODE_HTML_INLINE },
#else
            { "NODE_CUSTOM_BLOCK", CMARK_NODE_NONE },
            { "NODE_CUSTOM_INLINE", CMARK_NODE_NONE },
            { "NODE_HTML_BLOCK", CMARK_NODE_HTML },
            { "NODE_HEADING", CMARK_NODE_HEADER },
            { "NODE_THEMATIC_BREAK", CMARK_NODE_HRULE },
            { "NODE_HTML_INLINE", CMARK_NODE_INLINE_HTML },
#endif

            { "NO_LIST", CMARK_NO_LIST },
            { "BULLET_LIST", CMARK_BULLET_LIST },
            { "ORDERED_LIST", CMARK_ORDERED_LIST },

            { "NO_DELIM", CMARK_NO_DELIM },
            { "PERIOD_DELIM", CMARK_PERIOD_DELIM },
            { "PAREN_DELIM", CMARK_PAREN_DELIM },

            { "EVENT_NONE", CMARK_EVENT_NONE },
            { "EVENT_DONE", CMARK_EVENT_DONE },
            { "EVENT_ENTER", CMARK_EVENT_ENTER },
            { "EVENT_EXIT", CMARK_EVENT_EXIT },

            { "OPT_DEFAULT", CMARK_OPT_DEFAULT },
            { "OPT_SOURCEPOS", CMARK_OPT_SOURCEPOS },
            { "OPT_HARDBREAKS", CMARK_OPT_HARDBREAKS },
            { "OPT_SAFE", CMARK_OPT_SAFE },
#if CMARK_VERSION >= 0x001900
            /* libcmark 0.25.0 */
            { "OPT_NOBREAKS", CMARK_OPT_NOBREAKS },
#else
            { "OPT_NOBREAKS", 0 },
#endif
            { "OPT_NORMALIZE", CMARK_OPT_NORMALIZE },
            { "OPT_VALIDATE_UTF8", CMARK_OPT_VALIDATE_UTF8 },
            { "OPT_SMART", CMARK_OPT_SMART },
            { "OPT_UNSAFE", OPT_UNSAFE }
        };
        size_t num_constants = sizeof(constants) / sizeof(constants[0]);
        size_t i;
        HV *stash = gv_stashpv("CommonMark", 0);

        if (cmark_version() != CMARK_VERSION) {
            warn("Compiled against libcmark %s, but runtime version is %s",
                 CMARK_VERSION_STRING, cmark_version_string());
        }

        for (i = 0; i < num_constants; i++) {
            newCONSTSUB(stash, constants[i].name, newSViv(constants[i].value));
        }
    }

#line 1469 "CommonMark.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

